#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define MAX_MEMSIZE     0x20000

int DecodeIntelHexRecord(unsigned char *rec)
{
    register unsigned char *sp = rec;
    register unsigned char *dp = rec;
    unsigned char cs = 0;
    int rc = 0;

    if(*sp++ == ':') {
        strupr(sp);
        while(*sp >= '0' && *sp <= '9' || *sp >= 'A' && *sp <= 'F') {
            *dp = (*sp > '9' ? *sp - 55 : *sp - 48) << 4;
            *dp += *++sp > '9' ? *sp - 55 : *sp - 48;
            cs += *dp++;
            rc++;
            sp++;
        }
    }
    if(cs)
        rc = -1;
    return rc;
}

int main(int argc, char **argv)
{
    int rc = 0;
    unsigned char rec[128];
    unsigned char *image;
    int len;
    size_t addr;
    size_t seg = 0;
    size_t top = 0;
    FILE *fp;

    if(argc != 3) {
        fprintf(stderr, "usage: robi hexfile binfile\n");
        return 1;
    }

    if((fp = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Can't read %s\n", argv[1]);
        return 3;
    }

    image = malloc(MAX_MEMSIZE);
    memset(image, 0xFF, MAX_MEMSIZE);

    while(fgets(rec, sizeof(rec), fp)) {
        if((len = DecodeIntelHexRecord(rec)) < 0) {
            rc = 4;
            break;
        }
        if(len) {
            if(rec[3] == 0) {
                addr = seg + ((size_t)rec[1] << 8) + (size_t)rec[2];
                memcpy(image + addr, rec + 4, *rec);
                if((addr += *rec) > top)
                    top = addr;

            }
            else if(rec[3] == 2) {
                seg = (((size_t)rec[4] << 8) + (size_t)rec[5]) << 4;
            }
        }
    }
    fclose(fp);

    if((fp = fopen(argv[2], "wb")) == NULL) {
        fprintf(stderr, "Can't open %s\n", argv[2]);
        return 3;
    }
    if(fwrite(image, 1, top, fp) != top) {
        fprintf(stderr, "Can't write %s\n", argv[2]);
        rc = 3;
    }
    fclose(fp);

    free(image);

    return rc;
}
